/**
 * Based on editor_plugin_src.js
 *
 * Copyright 2009, Moxiecode Systems AB
 * Released under LGPL License.
 *
 * License: http://tinymce.moxiecode.com/license
 * Contributing: http://tinymce.moxiecode.com/contributing
 */

(function() {
	tinymce.create('tinymce.plugins.MoodleQuimPlugin', {
		init : function(ed, url) {
			// Register commands
			ed.addCommand('mceMoodleQuim', function() {
				// Internal image object like a flash placeholder
				if (ed.dom.getAttrib(ed.selection.getNode(), 'class', '').indexOf('mceItem') != -1)
					return;
				//Opens an internal window with the custom charmap.
				ed.windowManager.open({
					file : url + '/charmap.htm',
					width : 550 + parseInt(ed.getLang('advimage.delta_width', 0)),
					height : 265 + parseInt(ed.getLang('advimage.delta_height', 0)),
					inline : 1
				}, {
					plugin_url : url
				});
			});

			// Register buttons image : url + '/img/icon.gif',
			ed.addButton('moodlequim', {
				title : 'advimage.image_desc',
				image : url + '/img/icon.gif',
				cmd : 'mceMoodleQuim'
			});
		},

		getInfo : function() {
			return {
				longname : 'Moodle quim',
				author : '',
				authorurl : '',
                infourl : '',
                version : '3.6.0' // Version of AdvImage plugin this plugin is based on.
			};
		}
	});

	// Register plugin
	tinymce.PluginManager.add('moodlequim', tinymce.plugins.MoodleQuimPlugin);
})();